﻿<%@ Page Language="vb" AutoEventWireup="false" CodeBehind="GridWidth.aspx.vb" Inherits="InfragisticsProject.GridWidth" %>

<%@ Register Assembly="Infragistics4.Web.v15.2, Version=15.2.20152.2042, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" Namespace="Infragistics.Web.UI.GridControls" TagPrefix="ig" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">

    <title></title>
</head>
<body>
    <style>
        #textWidthChecker14 {
            font-family: verdana;
            text-align: left;
            font-size: 14px;
            padding-left:8px;
        }

        .noWrapCellStyle {
            white-space: nowrap;
        }

        tbody.gridOverflowStyle tr td {
            overflow: visible;
        }
    </style>

    <div >
        <span id="textWidthChecker14"></span>
    </div>

    <form id="form1" runat="server">
        <asp:ScriptManager ID="ScriptManager1" runat="server"></asp:ScriptManager>
        <div>
            <asp:UpdatePanel ID="UpdatePanel1" runat="server">
                <ContentTemplate>
                    <asp:Panel ID="Panel1" runat="server">        
                        
                        <ig:WebDataGrid ID="wdg1" runat="server" EnableAjax="False" AutoGenerateColumns="false" EnableDataViewState="True" EnableAjaxViewState="False" Height="390px" >
                            <Columns>
                                <ig:TemplateDataField Key="Name">
                                    <ItemTemplate>
                                        <asp:Label ID="lblName" runat="server" Text='<%# Eval("Name")%>'></asp:Label>
                                    </ItemTemplate>
                                    <Header Text="Name">
                                    </Header>
                                </ig:TemplateDataField>
                                <ig:TemplateDataField Key="Station ID">
                                    <ItemTemplate>
                                        <asp:Label ID="lblType" runat="server" Text='<%# Eval("City")%>'></asp:Label>
                                    </ItemTemplate>
                                    <Header Text="Station">
                                    </Header>
                                </ig:TemplateDataField>
                            </Columns>                             
                            <Behaviors>
                                <ig:Paging PagerAppearance="Bottom" />
                            </Behaviors>		                          
                        </ig:WebDataGrid>    
                    </asp:Panel>
                </ContentTemplate>
            </asp:UpdatePanel>
            <asp:Timer ID="Timer1" runat="server" Interval="5000"></asp:Timer>

        </div>
    </form>
</body>
</html>

<script type="text/javascript">

    if (typeof $IG ) {
        var adjustGridLayoutFunction = $IG.WebDataGrid.prototype._adjustGridLayout;
        $IG.WebDataGrid.prototype._originalAdjustGridLayout = adjustGridLayoutFunction;
        $IG.WebDataGrid.prototype._adjustGridLayout = function () {            
            resizeDashboardGrid(this);
            this._originalAdjustGridLayout();
        };
    }

    //Resizes dashboard grids based on font size selected for grid
    //requires a number of span IDs textWidthChecker (12-18) that
    //have styling in Dashboard.CSS that matches the header styling
    //of the grids to compare sizes

    function resizeDashboardGrid(grid) {
       
        var textWidthChecker = document.getElementById('textWidthChecker14');
        var columns = grid.get_columns();
        var row = grid.get_rows().get_row(0);
        var gridWidth = 0;
        for (colIdx = 0; colIdx < columns.get_length() ; colIdx++) {
           
            var col = columns.get_column(colIdx);
            textWidthChecker.innerHTML = col.get_headerText();
            var cellElement = row.get_cell(colIdx)._element;
            
            if (!col.get_hidden()) {
                if (textWidthChecker.offsetWidth > cellElement.offsetWidth) {
                    var newWidth = textWidthChecker.offsetWidth + 8;
                    col.set_width(newWidth + 'px');
                }
                // resize based on header text length
                if (col.get_headerElement().offsetWidth < col.get_headerText().length * 8) {
                    var newWidth = (col.get_headerText().length * 8).toString() + 'px';
                    col.set_width(newWidth);
                }
                gridWidth = col.get_w + gridWidth;
            }
        }
    }
</script>
